#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <variant>
#include <map>
#include <optional>

using namespace std;

enum class valtype {
    INT, DEC, STR, BOOL, KEYWORD, UNKNOWN
};

enum class keywords {
    IF, ELSE, WHILE, INT, DEC, STR, BOOL, FUN, RETURN,
    OPARE, CPARE, OBRAC, CBRAC,
    SET, ADDTO, SUBTRACTFROM, MULTIPLYTO, DIVIDEFROM,
    ADD, SUBTRACT, MULTIPLY, DIVIDE,
    EQUAL, INEQUAL, LESS, GREATER, EQLESS, EQGREATER,
    INCREMENT, DECREMENT,
    PRINT, LET, INPUT, EXIT,
    VALUE, SEMICOLON, VARIABLE
};

struct Value {
    valtype type;
    variant<int, double, string, bool> value;
};

struct Token {
    keywords keyword;
    Value value;
    valtype type = valtype::KEYWORD;
};

struct var {
    valtype type;
    variant<int, double, string, bool> value;

    string toString() const {
        if (type == valtype::INT) {
            return to_string(get<int>(value));
        }
        else if (type == valtype::DEC) {
            return to_string(get<double>(value));
        }
        else if (type == valtype::STR) {
            return get<string>(value);
        }
        else if (type == valtype::BOOL) {
            return to_string(get<bool>(value));
        } else {
            return "unknown";
        }
    }
};

// Global variable
extern bool debugMode;
extern string logList;